if {![info exists started1]} {set started1 0}
#set started1 0

if {$started1 == 0} {
    set started1 1

    set LogText ""
    set LogFlag 1

    proc log {s} {
        global LogText

        append LogText "$s\n"
        return ""
    }

    set Address 0x0000
    set Data 0x0000
    set DataBlock 0x0000
    set Length 1

    set AddressModifier A16
    set Digitizer -1
    set NumDigitizer 0
    for {set i 1} {$i <= 7} {incr i} {set Offset($i) 0}

    set FpgaList {"Use Probe Hardware"}
    set FpgaIDs {}       ;# 0 1 2 3 8 9 10 11 12
    set Fpga "Use Probe Hardware"

    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Init} m]
    if {$rc != 0} {
        log "Init returned with an error\n$m\n$errorCode\n$errorInfo"
    } else {
        set NumDigitizer $m
        log "discovered $NumDigitizer digitizer(s)"
    }

    set DigitizerList {}
    for {set i 0} {$i < $NumDigitizer} {incr i} {lappend DigitizerList $i}

#   access procedures

    set CorePresent 0        ;#   for current digitizer
    set SegmentPresent 0     ;#   for current digitizer
    for {set i 0} {$i <= 12} {incr i} {set Present($i) 0}     ;# index is fpga ID

    set ShortTimeOut 5000

proc click-probe {} {
    upvar Digitizer Digitizer
    upvar Present Present 
    upvar CorePresent CorePresent
    upvar SegmentPresent SegmentPresent
    upvar FpgaList FpgaList
    upvar FpgaIDs FpgaIDs
    upvar Fpga Fpga
    upvar ShortTimeOut ShortTimeOut

    set CorePresent 0
    set SegmentPresent 0
    for {set i 0} {$i <= 12} {incr i} {set Present($i) 0} 

    log "Digitizer= $Digitizer"

    set FpgaList {}
    set FpgaIDs {}

    log "probing for Core Main Board"

    set fpga 3     ;# core main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes

    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
        log "found it"
        lappend FpgaList "Core: Main Board"
        lappend FpgaIDs $fpga
        set CorePresent 1
        set Present($fpga) 1
    } else {
        log "Error returned [first [split $m \n]]"
     }

    if {$CorePresent == 1} {

       log "probing for Core ADCs"

       set fpga 2    ;# core ADCs
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
           log "found it"
           lappend FpgaList "Core: Virtex for core ADCs"
           lappend FpgaIDs $fpga
           set Present($fpga) 1
       } else {
           log "Error returned [first [split $m \n]]"
       }

       log "probing for Core segment ADC card #1"

       set fpga 0    ;# core segment ADC card #1
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
           log "found it"
           lappend FpgaList "Core: Virtex for Segment ADC card 1"
           lappend FpgaIDs $fpga
           set Present($fpga) 1
       } else {
           log "Error returned [first [split $m \n]]"
       }

       log "probing for Core segment ADC card #2"

       set fpga 1    ;# core segment ADC card #2
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
           log "found it"
           lappend FpgaList "Core: Virtex for Segment ADC card 2"
           lappend FpgaIDs $fpga
           set Present($fpga) 1
       } else {
           log "Error returned [first [split $m \n]]"
       }
    }

    log "probing for Segment Main Board"

    set fpga 12    ;# segment main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
        log "found it"
        lappend FpgaList "Segment: Main Board"
        lappend FpgaIDs $fpga
        set SegmentPresent 1
        set Present($fpga) 1
    } else {
        log "Error returned [first [split $m \n]]"
    }

    if {$SegmentPresent == 1} {

       log "probing for Segment ADC card #1"

       set fpga 8    ;# Segment ADC card #1
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
           log "found it"
           lappend FpgaList "Segment: Virtex for Segment ADC card 1"
           lappend FpgaIDs $fpga
           set Present($fpga) 1
       } else {
           log "Error returned [first [split $m \n]]"
       }

       log "probing for Segment ADC card #2"

       set fpga 9    ;# Segment ADC card #2
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
           log "found it"
           lappend FpgaList "Segment: Virtex for Segment ADC card 2"
           lappend FpgaIDs $fpga
           set Present($fpga) 1
       } else {
           log "Error returned [first [split $m \n]]"
       }

       log "probing for Segment ADC card #3"

       set fpga 10    ;# Segment ADC card #3
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
           log "found it"
           lappend FpgaList "Segment: Virtex for Segment ADC card 3"
           lappend FpgaIDs $fpga
           set Present($fpga) 1
       } else {
           log "Error returned [first [split $m \n]]"
       }

       log "probing for Segment ADC card #4"

       set fpga 11    ;# Segment ADC card #4
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
           log "found it"
           lappend FpgaList "Segment: Virtex for Segment ADC card 4"
           lappend FpgaIDs $fpga
           set Present($fpga) 1
       } else {
           log "Error returned [first [split $m \n]]"
       }
   }

   set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer 0} m]   ;# reset timeout to default

   if {[expr $CorePresent + $SegmentPresent] == 0} {
       log "Digitizer not found"
       set FpgaList {"Digitizer not found"}
       set Digitizer -1
   } else {
       log "Found Digitizer $Digitizer which consists of:"
       foreach item $FpgaList {log $item}
   }
   set Fpga [first $FpgaList]

}

proc click-readprom {} {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier
        global errorCode errorInfo

set Prom_control 0x880
set Prom_status 0x881
set Prom_base 0x800

        if {$Digitizer == -1} {
            InsertLog "Use \"Probe Hardware\" and select a Digitizer"
            return
        }

        if {$Fpga == "Use Probe Hardware"} {
            InsertLog "Use \"Probe Hardware\" and select an FPGA"
            return
        }

    log "Digitizer= $Digitizer"

    log "Read PROM"

#    not available for Main Boards

        if {$Fpga == "Core: Main Board" || $Fpga == "Segment: Main Board"} {
            InsertLog "Not available for Main Boards"
            return
        }

# check to see if it has read in correctly 

        set a [ Get_Register $Prom_status ]
	if { $a != 4 } {
             InsertLog "Prom has read back unsuccessfully. Status : $a"
             return
        }

	InsertLog "Prom Read back into RAM"

	set a [ format "%c" [ Get_Register 0x800 ] ]
	
	if { $a == "C" } {
		InsertLog "This is a Core ADC board"
	} elseif { $a == "S" } {
		InsertLog "This is a Segment ADC board" 
	} else {
		InsertLog "Not sure what this is : [ format "%c" $a ] !"
	}
	set a [ Get_Register 0x801 ]
	set b [ Get_Register 0x802 ]
	set c [ Get_Register 0x803 ]
	set d [ Get_Register 0x804 ]
	set e [ Get_Register 0x805 ]
	set f [ Get_Register 0x806 ]
	set g [ Get_Register 0x807 ]
	set serial [ format "%c%c%c%c" $d $c $b $a ]
	set revision [ format "%c" $e ]
	set mod_state [ format "%c%c" $g $f ]

	InsertLog "Serial number : $serial"
	InsertLog "Revision      : $revision"
	InsertLog "Mod state     : $mod_state"
	InsertLog "Test Complete ....."

}

proc click-setup {} {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier
        upvar Offset Offset

# set the external clock option
	if { [SelectFpga "Core: Main Board"] == -1 } then { 
		InsertLog "Can't connect to Main board" 
		return
	}
	set rtnd 0
	Set_Register 40 0 

# enable the Core Laser and push it's DCMs to lock.

	if { [SelectFpga "Core: Virtex for core ADCs"] == -1 } then { 
		InsertLog "No Core card available !" 
		return
	}

# set the sync pulse to be correctly transmitted

	Set_Register 11 1
	
# set the basics - inpsection and main enables
	Set_Register 4 0

	Set_Register 7 0x300
	Set_Register 0 0x175
	Set_Register 0 0x75
 	set val [Get_Register 1 ]
	set val [ expr $val & 0xfffD ]
 	if { $val != 0xf205 } then {
		InsertLog "Core status  fault : ([format "0x%x" $val])"
		InsertLog "Is the cable connected ?"
	}
	setup_core  
	setup_segment "Core: Virtex for Segment ADC card 1" 
	setup_segment "Core: Virtex for Segment ADC card 2" 
	setup_segment "Segment: Virtex for Segment ADC card 1" 
	setup_segment "Segment: Virtex for Segment ADC card 2" 
	setup_segment "Segment: Virtex for Segment ADC card 3" 
	setup_segment "Segment: Virtex for Segment ADC card 4" 

      InsertLog "Setup Complete ....."
}

proc click-setupfpga {} {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier
        upvar Offset Offset

        if {$Fpga == "Core: Main Board" || $Fpga == "Segment: Main Board"} {
            InsertLog "Not available for Main Boards"
            return
        }

        if {$Fpga == "Core: Virtex for core ADCs"} {setup_core} else {setup_segment $Fpga}

        InsertLog "Setup $Fpga Complete ....."

}

proc setup_segment { board } {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier
        upvar Offset Offset

	set rtnd 0

	if { [SelectFpga "$board"] == -1 } then { 
		InsertLog "Segment card --- %board---- not available !" 
		return
	}
# set the basics  disable inspection and main enables
	setup_offset_seg
# enable the laser
	Set_Register 0 5
	Set_Register 4 0
	Set_Register 7 0xFF00

# check the status register for DCM locked.
	set val [Get_Register 1 ]
	if { $val != 0xe001 } {
		InsertLog "Segment status  fault : ([format "0x%x" $val])"
	        return
	}
# channel by channel set transmit data enabled
	foreach val { 1 2 3 4 5 6 } {
		set ch_rkt [expr ( $val << 4 ) + 3 ]
		Set_Register $ch_rkt 0x7c00
		set ch_rkt [expr ( $val << 4 ) + 4 ]
		Set_Register $ch_rkt 0
	}
# aving these as two separate or statements allows link synch.
	foreach val { 1 2 3 4 5 6 } {
		set ch_rkt [expr ( $val << 4 ) + 3 ]
		Set_Register $ch_rkt 0
	}
	
}

proc setup_core {} {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier
        upvar Offset Offset

	if { [SelectFpga "Core: Virtex for core ADCs"] == -1 } then { 
		WaitForUser "No Core card available !" 
		return
	}
# set the basics - inspection and main enables
	setup_offset_core
	Set_Register 4 0
	Set_Register 7 0x300

# channel by channel set transmit data enabled
	foreach val { 1 2  } {
		set ch_rkt [expr ( $val << 4 ) + 3 ]
		Set_Register $ch_rkt 0x7c00
		set ch_rkt [expr ( $val << 4 ) + 4 ]
		Set_Register $ch_rkt 0
	}
	foreach val { 1 2  } {
		set ch_rkt [expr ( $val << 4 ) + 3 ]
		Set_Register $ch_rkt 0
	}
}

proc setup_offset_core {} {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier
        upvar Offset Offset

        for {set i 1} {$i <= 2} {incr i} {Set_Register [expr 0x80 + $i] [set Offset($i)]; InsertLog "Set Offset $i = [set Offset($i)]"}
}

proc setup_offset_seg {} {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier
        upvar Offset Offset

        for {set i 1} {$i <= 7} {incr i} {Set_Register [expr 0x80 + $i] [set Offset($i)]; InsertLog "Set Offset $i = [set Offset($i)]"}
}


    proc SelectFpga {n} {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier

       if {[lsearch $FpgaList $n] == -1 || [lindex $FpgaIDs [lsearch $FpgaList $n]] == -1} {
           InsertLog "$n is a bad Fpga"
           return -1
       } else {
           set Fpga $n
       }
       return [set Fpga]
    }

    proc Get_Register {Addr {Space A16}} {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier
        global errorCode errorInfo

        set Address $Addr
        set AddressModifier $Space

        set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]

        if {$AddressModifier == "A16"} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Address $AddressModifier} m]
        } else {
            set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $Address $AddressModifier 1} m]
        }
        if {$rc != 0} {
            InsertLog "Get_Register: $Digitizer $fpga $Address $AddressModifier"
            InsertLog "Get_Register returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
   }

   proc Set_Register {Addr Data {Space A16}}  {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier
        global errorCode errorInfo

        set Address $Addr
        set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $Address $AddressModifier 1 $Data} m]
        if {$rc != 0} {
            InsertLog "Set_Register: $Digitizer $fpga $Address $AddressModifier 1 $Data"
            InsertLog "Set_Register returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
   }

   proc InsertLog {s} {log $s}

    proc do_get {} {
        upvar  Digitizer Digitizer
        upvar  Fpga Fpga
        upvar  FpgaList FpgaList
        upvar  FpgaIDs FpgaIDs
        upvar  Address Address
        upvar  AddressModifier AddressModifier
        global errorCode errorInfo

        set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]

        if {$AddressModifier == "A16"} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Address A16} m]
        } else {
            set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $Address A32 1} m]
        }
        if {$rc != 0} {
            log "Get returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            log "Get returned $m ([format "0x%x" $m])"
        }
    }

    proc do_read {} {
        upvar Digitizer Digitizer
        upvar Fpga Fpga
        upvar FpgaList FpgaList
        upvar FpgaIDs FpgaIDs
        upvar Address Address
        upvar Length Length
        upvar AddressModifier AddressModifier
        global errorCode errorInfo

        set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $Address $AddressModifier $Length} m]
        if {$rc != 0} {
            log "Read returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            log "Read returned $m"
        }
    }

    proc do_write {} {
        upvar Digitizer Digitizer
        upvar Fpga Fpga
        upvar FpgaList FpgaList
        upvar FpgaIDs FpgaIDs
        upvar Address Address
        upvar DataBlock DataBlock
        upvar AddressModifier AddressModifier
        global errorCode errorInfo

        set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $Address $AddressModifier [llength $DataBlock] $DataBlock} m]
        if {$rc != 0} {
            log "Write returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            log "Write returned $m ([format "0x%x" $m])"
        }
    }

    proc do_shutdown {} {
        upvar Digitizer Digitizer
        upvar Fpga Fpga
        upvar FpgaList FpgaList
        upvar FpgaIDs FpgaIDs
        global errorCode errorInfo

        set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]
        if {$fpga < 8} then {set fpga 3} else {set fpga 12}    ;# select main board

        set cmd 20     ;# shutdown command

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $cmd A16 1 0x0800} m]
        if {$rc == 0} {
            log "Done"
        } else {
            log "Write returned with an error\n$m\n$errorCode\n$errorInfo"
        }
    }

    proc do_showstatus {} {
        upvar Digitizer Digitizer
        upvar Fpga Fpga
        upvar FpgaList FpgaList
        upvar FpgaIDs FpgaIDs
        global errorCode errorInfo

        set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]
        if {$fpga < 8} then {set fpga 3} else {set fpga 12}    ;# select main board

        set cmd 14     ;# read status registers command
        set Length 6   ;# returns 6 bytes
        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
        if {$rc == 0} {
            log "status registers: $m"
        } else {
            log "Write returned with an error\n$m\n$errorCode\n$errorInfo"
        }
    }

    proc do_clock {vl} {
        upvar Digitizer Digitizer
        global errorCode errorInfo

        set fpga 3    ;#  available to core main board only
        set cmd 40

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $cmd A16 1 $vl} m]
        if {$rc != 0} {
            log "Set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            log "Set returned $m ([format "0x%x" $m])"
        }
    }

    proc do_set {} {
        upvar Digitizer Digitizer
        upvar Fpga Fpga
        upvar FpgaList FpgaList
        upvar FpgaIDs FpgaIDs
        upvar Address Address
        upvar AddressModifier AddressModifier
        upvar Data Data
        global errorCode errorInfo

        set fpga [lindex $FpgaIDs [lsearch $FpgaList $Fpga]]

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $Address $AddressModifier 1 $Data} m]
        if {$rc != 0} {
            log "Set returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            log "Set returned $m ([format "0x%x" $m])"
        }
    }

    proc do_parameters {} {
        upvar cgidata cgidata
        upvar Digitizer Digitizer
        upvar Fpga Fpga
        upvar Address Address
        upvar AddressModifier AddressModifier
        upvar Data Data
        upvar Length Length
        upvar DataBlock DataBlock
        upvar Offset Offset

        for {set i 2} {$i < [llength $cgidata]} {incr i} {

            set name [lindex $cgidata $i]
            incr i
            set value [lindex $cgidata $i]

            switch -glob $name {
               Offset*_value  {
                   set n [string range $name 6 6]
                   set Offset($n) $value
#                   log "Offset($n) = $value"
               }
               AddressModifier -
               Fpga -
               Digitizer  -
               Address  -
               Length -
               DataBlock -
               Data  {
                   set $name $value
 #                  log "$name = $value"
               }
            }
        }
   }

}   ;# end of if {$started1 == 0} 
